; Programa, perraanti 1 pertraukimo apdorojimo procedura; procedura atpaista komanda MOV ir iveda i ekrana jos bita w
;***************************************************************

.model small

.stack 100h

.data
	PranMOV	db "Komanda AND, w= $"
	PranMOV2 db "Komanda AND, d= $"
	PranMov3 db "Komanda AND, $"
	PranD db " d=$"
	PranW db "w=$"
	PranS db " s=$"
	Enteris db 13, 10, "$"
	PranNe	db "Komanda ne AND", 13, 10, "$"

.code
  Pradzia:
	MOV	ax, @data	;reikalinga kiekvienos programos pradioj
	MOV	ds, ax		;reikalinga kiekvienos programos pradioj

;****************************************************************************
; Nusistatom reikalingas registru reikmes
;****************************************************************************
	MOV	ax, 0		;nera komandos MOV es, 0 - tai reikia daryti per darbini registra (ax)
	MOV	es, ax		;i es isiraome 0, nes pertraukimu vektoriu lentele yra segmente, kurio pradios adresas yra 00000
	
;****************************************************************************
; Iisaugome tikra pertraukimo apdorojimo proceduros adresa, kad programos gale galetume ji atstatyti
;****************************************************************************
	PUSH	es:[4]
	PUSH	es:[6]
	
;****************************************************************************
; Pertraukimu vektoriu lenteleje suformuojame pertraukimo apdorojimo proceduros adresa
;****************************************************************************
	MOV	word ptr es:[4], offset ApdorokPertr	;i pertraukimu vektoriu lentele iraome pertraukimo apdorojimo proceduros poslinki nuo kodo segmento pradios
	MOV	es:[6], cs				;i pertraukimu vektoriu lentele iraome pertraukimo apdorojimo proceduros segmenta

;****************************************************************************
; Testuojame pertraukimo apdorojimo procedura
;****************************************************************************
	PUSHF			;Isisaugome SF reikme testavimo pradioje
	PUSHF			;Isisaugome SF kad galetume ja iimti ir nustatyti TF
	POP ax			;Iimame SF reikme i TF
	OR ax, 0100h		;Nustatome TF=1
	PUSH ax			;Idedame pakoreguota reikme
	POPF			;Iimame pakoreguota reikme i SF; Nuo cia TF=1
	NOP			;Pirmas pertraukimas kyla ne prie ia komanda, o po jos; todel tiesiog viena komanda nieko nedarome
	
	MOV	ax, bx		;ita komanda nagrines pertraukimo apdorojimo procedura
	MOV	ax, cs		;ita komanda nagrines pertraukimo apdorojimo procedura
	MOV	al, 22h		;ita komanda nagrines pertraukimo apdorojimo procedura
	INC ax			;ita komanda nagrines pertraukimo apdorojimo procedura
	
	POPF			;Itraukiame i steko testavimo pradioje buvusia SF reikme
				;Kadangi tada TF buvo lygi 0, tai tokiu budu numuame TF
	
;****************************************************************************
; Atstatome tikra pertraukimo apdorojimo programos adresa pertraukimu vektoriuje
;****************************************************************************
	POP	es:[6]
	POP	es:[4]

	MOV	ah, 4Ch		;reikalinga kiekvienos programos pabaigoj
	MOV	al, 0		;reikalinga kiekvienos programos pabaigoj
	INT	21h		;reikalinga kiekvienos programos pabaigoj

;****************************************************************************
; Pertraukimo apdorojimo procedura
;****************************************************************************
  PROC ApdorokPertr
	;Idedame registru reikmes i steka
	PUSH	ax
	PUSH	bx
	PUSH	dx
	PUSH	bp
	PUSH	es
	PUSH	ds

	;Nustatome DS reikme, jei pertraukima ikviestu kita programa
	MOV	ax, @data
	MOV	ds, ax

	;I registra DL isiraom komandos, prie kuria buvo ikviestas INT, operacijos koda
	MOV bp, sp		;Darbui su steku patogiausia naudoti registrq BP
	ADD bp, 12		;Suskaiciuojame kaip giliai steke yra idetas griimo adresas
	MOV bx, [bp]		;I bx idedame griimo adreso poslinki nuo segmento pradios (IP)
	MOV es, [bp+2]		;I es idedame griimo adreso segmenta (CS)
	MOV dl, [es:bx]		;Iimame pirmaji baita, esanti griimo adresu - komandos OPK
	MOV dl, 25h
	
	;Tikriname, ar INT buvo ikviestas prie komanda MOV
	MOV al, dl
	AND al, 0FCh		;Tikriname pagal pirmus 6 OPK bitus
	CMP al, 20h		;Ar tai MOV registras <--> registras / atmintis - 1000 10dw
	JE  mov4
	CMP al, 80h
	JE mov5
	
	
	
	MOV al, dl
	AND al, 0FEh		;Tikriname pagal pirmus 7 OPK bitus
	CMP al, 24h		;Ar tai MOV registras / atmintis <- betarpikas operandas - 1100 011w
	JE 	mov1
	;CMP al, 0A0h		;Ar tai MOV akumuliatorius <- atmintis - 1010 000w
	;JE	mov1
	;CMP al, 0A2h		;Ar tai MOV atmintis <- akumuliatorius - 1010 001w
	;JE	mov1
	;MOV al, dl
	;AND al, 0F0h		;Tikriname pagal pirmus 4 bitus
	;CMP al, 0B0h		;Ar tai MOV registras <- betarpikas operandas - 1011 wreg
	;JE	mov2
	;MOV al, dl
	;AND al, 0FDh		;Tikriname pagal pirmus 6 bitus ir paskutiniji bita
	;CMP al, 8Ch		;Ar tai MOV registras / atmintis <--> segmento registras - 1000 11d0
	;JE	mov3
	
	;Jei INT buvo ikviestas ne prie komanda MOV, tai ivedame praneima
	MOV ah, 9
	MOV dx, offset PranNe
	INT 21h
	JMP pabaiga

	;Jei INT buvo ikviestas prie komanda MOV, tai tada dl registre suformuojame bito w reikme
Mov1:
	AND dl, 1		;iuo atveju w yra paskutinis bitas, taigi ivalom kitus bitus
	ADD dl, 30h		;Padarom ASCII koda
	JMP Spausdink
Mov2:
	MOV cl, 3
	SHR dl, cl		;iuo atveju w yra ketvirtas bitas i deines, padarom, kad jis butu paskutinis
	JMP Mov1		;ir elgiames taip pat kaip ir Mov1 atveju
Mov3:
	AND DL, 2
	MOV CL, 1
	SHR DL, CL
	MOV dl, 31h		;iuo atveju w bito nera, bet galima laikyti, kad w=1, nes visada veiksmai atliekami su odio dydio registrais
	JMP Spausdink2
	
Mov4:

	MOV AH,09h
	
	PUSH DX
		MOV DX, offset PranMov3
		int 21h
	POP DX
	
	PUSH DX
		MOV DX, offset PranW
		int 21h
	POP DX
	
	PUSH DX	
	MOV AH, 02h
	AND dl, 2	
    MOV CL, 1
    SHR DL, CL	
	ADD dl, 30h
	int 21h	
	POP DX
	
	MOV AH, 09h
	
	PUSH DX
		MOV DX, offset PranD
		int 21h
	POP DX
	
	PUSH DX	
	MOV AH, 02h
	AND dl, 1	
	ADD dl, 30h
	int 21h	
	POP DX
	
	MOV AH, 09h
	
	PUSH DX
		MOV DX, offset enteris
		int 21h
	POP DX
	
jmp pabaiga

Mov5:

	MOV AH,09h
	
	PUSH DX
		MOV DX, offset PranMov3
		int 21h
	POP DX
	
	PUSH DX
		MOV DX, offset PranW
		int 21h
	POP DX
	
	PUSH DX	
	MOV AH, 02h
	AND dl, 2	
    MOV CL, 1
    SHR DL, CL	
	ADD dl, 30h
	int 21h	
	POP DX
	
	MOV AH, 09h
	
	PUSH DX
		MOV DX, offset PranS
		int 21h
	POP DX
	
	PUSH DX	
	MOV AH, 02h
	AND dl, 1	
	ADD dl, 30h
	int 21h	
	POP DX
	
	MOV AH, 09h
	
	PUSH DX
		MOV DX, offset enteris
		int 21h
	POP DX
	
jmp pabaiga
	
	
Spausdink2:
	PUSH dx			;Registre dl suformuota bito w reikme, todel, kad jos nesugadintume, isaugome i steka
	MOV ah, 9
	MOV dx, offset PranMOV2
	INT 21h
	
	MOV ah, 2
	POP dx
	INT 21h
	
	MOV ah, 9
	MOV dx, offset enteris
	INT 21h
	JMP pabaiga

	;Ivedame praneima ir bito w reikme
Spausdink:
	PUSH dx			;Registre dl suformuota bito w reikme, todel, kad jos nesugadintume, isaugome i steka
	MOV ah, 9
	MOV dx, offset PranMOV
	INT 21h
	
	MOV ah, 2
	POP dx
	INT 21h
	
	MOV ah, 9
	MOV dx, offset enteris
	INT 21h

	;Atstatome registru reikmes ir ieiname i pertraukimo apdorojimo proceduros
Pabaiga:
	POP ds
	POP es
	POP bp
	POP	dx
	POP bx
	POP	ax
	IRET			;pabaigoje butina naudoti griimo i pertraukimo apdorojimo proceduros komanda IRET
				;paprastas RET netinka, nes per maai informacijos iima i steko
ApdorokPertr ENDP

END Pradzia